package javax.vecmath;

import java.io.Serializable;

public abstract class Tuple2d implements Serializable, Cloneable {
   static final long serialVersionUID = 6205762482756093838L;
   // $FF: renamed from: x double
   public double field_0;
   // $FF: renamed from: y double
   public double field_1;

   public Tuple2d(double var1, double var3) {
      this.field_0 = var1;
      this.field_1 = var3;
   }

   public Tuple2d(double[] var1) {
      this.field_0 = var1[0];
      this.field_1 = var1[1];
   }

   public Tuple2d(Tuple2d var1) {
      this.field_0 = var1.field_0;
      this.field_1 = var1.field_1;
   }

   public Tuple2d(Tuple2f var1) {
      this.field_0 = (double)var1.x;
      this.field_1 = (double)var1.y;
   }

   public Tuple2d() {
      this.field_0 = (double)0.0F;
      this.field_1 = (double)0.0F;
   }

   public final void set(double var1, double var3) {
      this.field_0 = var1;
      this.field_1 = var3;
   }

   public final void set(double[] var1) {
      this.field_0 = var1[0];
      this.field_1 = var1[1];
   }

   public final void set(Tuple2d var1) {
      this.field_0 = var1.field_0;
      this.field_1 = var1.field_1;
   }

   public final void set(Tuple2f var1) {
      this.field_0 = (double)var1.x;
      this.field_1 = (double)var1.y;
   }

   public final void get(double[] var1) {
      var1[0] = this.field_0;
      var1[1] = this.field_1;
   }

   public final void add(Tuple2d var1, Tuple2d var2) {
      this.field_0 = var1.field_0 + var2.field_0;
      this.field_1 = var1.field_1 + var2.field_1;
   }

   public final void add(Tuple2d var1) {
      this.field_0 += var1.field_0;
      this.field_1 += var1.field_1;
   }

   public final void sub(Tuple2d var1, Tuple2d var2) {
      this.field_0 = var1.field_0 - var2.field_0;
      this.field_1 = var1.field_1 - var2.field_1;
   }

   public final void sub(Tuple2d var1) {
      this.field_0 -= var1.field_0;
      this.field_1 -= var1.field_1;
   }

   public final void negate(Tuple2d var1) {
      this.field_0 = -var1.field_0;
      this.field_1 = -var1.field_1;
   }

   public final void negate() {
      this.field_0 = -this.field_0;
      this.field_1 = -this.field_1;
   }

   public final void scale(double var1, Tuple2d var3) {
      this.field_0 = var1 * var3.field_0;
      this.field_1 = var1 * var3.field_1;
   }

   public final void scale(double var1) {
      this.field_0 *= var1;
      this.field_1 *= var1;
   }

   public final void scaleAdd(double var1, Tuple2d var3, Tuple2d var4) {
      this.field_0 = var1 * var3.field_0 + var4.field_0;
      this.field_1 = var1 * var3.field_1 + var4.field_1;
   }

   public final void scaleAdd(double var1, Tuple2d var3) {
      this.field_0 = var1 * this.field_0 + var3.field_0;
      this.field_1 = var1 * this.field_1 + var3.field_1;
   }

   public int hashCode() {
      long var1 = 1L;
      var1 = 31L * var1 + Double.doubleToLongBits(this.field_0);
      var1 = 31L * var1 + Double.doubleToLongBits(this.field_1);
      return (int)(var1 ^ var1 >> 32);
   }

   public boolean equals(Tuple2d var1) {
      try {
         return this.field_0 == var1.field_0 && this.field_1 == var1.field_1;
      } catch (NullPointerException var3) {
         return false;
      }
   }

   public boolean equals(Object var1) {
      try {
         Tuple2d var2 = (Tuple2d)var1;
         return this.field_0 == var2.field_0 && this.field_1 == var2.field_1;
      } catch (NullPointerException var4) {
         return false;
      } catch (ClassCastException var5) {
         return false;
      }
   }

   public boolean epsilonEquals(Tuple2d var1, double var2) {
      double var4 = this.field_0 - var1.field_0;
      if ((var4 < (double)0.0F ? -var4 : var4) > var2) {
         return false;
      } else {
         var4 = this.field_1 - var1.field_1;
         return !((var4 < (double)0.0F ? -var4 : var4) > var2);
      }
   }

   public String toString() {
      return "(" + this.field_0 + ", " + this.field_1 + ")";
   }

   public final void clamp(double var1, double var3, Tuple2d var5) {
      if (var5.field_0 > var3) {
         this.field_0 = var3;
      } else if (var5.field_0 < var1) {
         this.field_0 = var1;
      } else {
         this.field_0 = var5.field_0;
      }

      if (var5.field_1 > var3) {
         this.field_1 = var3;
      } else if (var5.field_1 < var1) {
         this.field_1 = var1;
      } else {
         this.field_1 = var5.field_1;
      }

   }

   public final void clampMin(double var1, Tuple2d var3) {
      if (var3.field_0 < var1) {
         this.field_0 = var1;
      } else {
         this.field_0 = var3.field_0;
      }

      if (var3.field_1 < var1) {
         this.field_1 = var1;
      } else {
         this.field_1 = var3.field_1;
      }

   }

   public final void clampMax(double var1, Tuple2d var3) {
      if (var3.field_0 > var1) {
         this.field_0 = var1;
      } else {
         this.field_0 = var3.field_0;
      }

      if (var3.field_1 > var1) {
         this.field_1 = var1;
      } else {
         this.field_1 = var3.field_1;
      }

   }

   public final void absolute(Tuple2d var1) {
      this.field_0 = Math.abs(var1.field_0);
      this.field_1 = Math.abs(var1.field_1);
   }

   public final void clamp(double var1, double var3) {
      if (this.field_0 > var3) {
         this.field_0 = var3;
      } else if (this.field_0 < var1) {
         this.field_0 = var1;
      }

      if (this.field_1 > var3) {
         this.field_1 = var3;
      } else if (this.field_1 < var1) {
         this.field_1 = var1;
      }

   }

   public final void clampMin(double var1) {
      if (this.field_0 < var1) {
         this.field_0 = var1;
      }

      if (this.field_1 < var1) {
         this.field_1 = var1;
      }

   }

   public final void clampMax(double var1) {
      if (this.field_0 > var1) {
         this.field_0 = var1;
      }

      if (this.field_1 > var1) {
         this.field_1 = var1;
      }

   }

   public final void absolute() {
      this.field_0 = Math.abs(this.field_0);
      this.field_1 = Math.abs(this.field_1);
   }

   public final void interpolate(Tuple2d var1, Tuple2d var2, double var3) {
      this.field_0 = ((double)1.0F - var3) * var1.field_0 + var3 * var2.field_0;
      this.field_1 = ((double)1.0F - var3) * var1.field_1 + var3 * var2.field_1;
   }

   public final void interpolate(Tuple2d var1, double var2) {
      this.field_0 = ((double)1.0F - var2) * this.field_0 + var2 * var1.field_0;
      this.field_1 = ((double)1.0F - var2) * this.field_1 + var2 * var1.field_1;
   }

   public Object clone() {
      try {
         return super.clone();
      } catch (CloneNotSupportedException var2) {
         throw new InternalError();
      }
   }
}
