package javax.vecmath;

import java.io.Serializable;

public abstract class Tuple2f implements Serializable, Cloneable {
   static final long serialVersionUID = 9011180388985266884L;
   // $FF: renamed from: x float
   public float field_0;
   // $FF: renamed from: y float
   public float field_1;

   public Tuple2f(float var1, float var2) {
      this.field_0 = var1;
      this.field_1 = var2;
   }

   public Tuple2f(float[] var1) {
      this.field_0 = var1[0];
      this.field_1 = var1[1];
   }

   public Tuple2f(Tuple2f var1) {
      this.field_0 = var1.field_0;
      this.field_1 = var1.field_1;
   }

   public Tuple2f(Tuple2d var1) {
      this.field_0 = (float)var1.x;
      this.field_1 = (float)var1.y;
   }

   public Tuple2f() {
      this.field_0 = 0.0F;
      this.field_1 = 0.0F;
   }

   public final void set(float var1, float var2) {
      this.field_0 = var1;
      this.field_1 = var2;
   }

   public final void set(float[] var1) {
      this.field_0 = var1[0];
      this.field_1 = var1[1];
   }

   public final void set(Tuple2f var1) {
      this.field_0 = var1.field_0;
      this.field_1 = var1.field_1;
   }

   public final void set(Tuple2d var1) {
      this.field_0 = (float)var1.x;
      this.field_1 = (float)var1.y;
   }

   public final void get(float[] var1) {
      var1[0] = this.field_0;
      var1[1] = this.field_1;
   }

   public final void add(Tuple2f var1, Tuple2f var2) {
      this.field_0 = var1.field_0 + var2.field_0;
      this.field_1 = var1.field_1 + var2.field_1;
   }

   public final void add(Tuple2f var1) {
      this.field_0 += var1.field_0;
      this.field_1 += var1.field_1;
   }

   public final void sub(Tuple2f var1, Tuple2f var2) {
      this.field_0 = var1.field_0 - var2.field_0;
      this.field_1 = var1.field_1 - var2.field_1;
   }

   public final void sub(Tuple2f var1) {
      this.field_0 -= var1.field_0;
      this.field_1 -= var1.field_1;
   }

   public final void negate(Tuple2f var1) {
      this.field_0 = -var1.field_0;
      this.field_1 = -var1.field_1;
   }

   public final void negate() {
      this.field_0 = -this.field_0;
      this.field_1 = -this.field_1;
   }

   public final void scale(float var1, Tuple2f var2) {
      this.field_0 = var1 * var2.field_0;
      this.field_1 = var1 * var2.field_1;
   }

   public final void scale(float var1) {
      this.field_0 *= var1;
      this.field_1 *= var1;
   }

   public final void scaleAdd(float var1, Tuple2f var2, Tuple2f var3) {
      this.field_0 = var1 * var2.field_0 + var3.field_0;
      this.field_1 = var1 * var2.field_1 + var3.field_1;
   }

   public final void scaleAdd(float var1, Tuple2f var2) {
      this.field_0 = var1 * this.field_0 + var2.field_0;
      this.field_1 = var1 * this.field_1 + var2.field_1;
   }

   public int hashCode() {
      long var1 = 1L;
      var1 = 31L * var1 + (long)Float.floatToIntBits(this.field_0);
      var1 = 31L * var1 + (long)Float.floatToIntBits(this.field_1);
      return (int)(var1 ^ var1 >> 32);
   }

   public boolean equals(Tuple2f var1) {
      try {
         return this.field_0 == var1.field_0 && this.field_1 == var1.field_1;
      } catch (NullPointerException var3) {
         return false;
      }
   }

   public boolean equals(Object var1) {
      try {
         Tuple2f var2 = (Tuple2f)var1;
         return this.field_0 == var2.field_0 && this.field_1 == var2.field_1;
      } catch (NullPointerException var4) {
         return false;
      } catch (ClassCastException var5) {
         return false;
      }
   }

   public boolean epsilonEquals(Tuple2f var1, float var2) {
      float var3 = this.field_0 - var1.field_0;
      if ((var3 < 0.0F ? -var3 : var3) > var2) {
         return false;
      } else {
         var3 = this.field_1 - var1.field_1;
         return !((var3 < 0.0F ? -var3 : var3) > var2);
      }
   }

   public String toString() {
      return "(" + this.field_0 + ", " + this.field_1 + ")";
   }

   public final void clamp(float var1, float var2, Tuple2f var3) {
      if (var3.field_0 > var2) {
         this.field_0 = var2;
      } else if (var3.field_0 < var1) {
         this.field_0 = var1;
      } else {
         this.field_0 = var3.field_0;
      }

      if (var3.field_1 > var2) {
         this.field_1 = var2;
      } else if (var3.field_1 < var1) {
         this.field_1 = var1;
      } else {
         this.field_1 = var3.field_1;
      }

   }

   public final void clampMin(float var1, Tuple2f var2) {
      if (var2.field_0 < var1) {
         this.field_0 = var1;
      } else {
         this.field_0 = var2.field_0;
      }

      if (var2.field_1 < var1) {
         this.field_1 = var1;
      } else {
         this.field_1 = var2.field_1;
      }

   }

   public final void clampMax(float var1, Tuple2f var2) {
      if (var2.field_0 > var1) {
         this.field_0 = var1;
      } else {
         this.field_0 = var2.field_0;
      }

      if (var2.field_1 > var1) {
         this.field_1 = var1;
      } else {
         this.field_1 = var2.field_1;
      }

   }

   public final void absolute(Tuple2f var1) {
      this.field_0 = Math.abs(var1.field_0);
      this.field_1 = Math.abs(var1.field_1);
   }

   public final void clamp(float var1, float var2) {
      if (this.field_0 > var2) {
         this.field_0 = var2;
      } else if (this.field_0 < var1) {
         this.field_0 = var1;
      }

      if (this.field_1 > var2) {
         this.field_1 = var2;
      } else if (this.field_1 < var1) {
         this.field_1 = var1;
      }

   }

   public final void clampMin(float var1) {
      if (this.field_0 < var1) {
         this.field_0 = var1;
      }

      if (this.field_1 < var1) {
         this.field_1 = var1;
      }

   }

   public final void clampMax(float var1) {
      if (this.field_0 > var1) {
         this.field_0 = var1;
      }

      if (this.field_1 > var1) {
         this.field_1 = var1;
      }

   }

   public final void absolute() {
      this.field_0 = Math.abs(this.field_0);
      this.field_1 = Math.abs(this.field_1);
   }

   public final void interpolate(Tuple2f var1, Tuple2f var2, float var3) {
      this.field_0 = (1.0F - var3) * var1.field_0 + var3 * var2.field_0;
      this.field_1 = (1.0F - var3) * var1.field_1 + var3 * var2.field_1;
   }

   public final void interpolate(Tuple2f var1, float var2) {
      this.field_0 = (1.0F - var2) * this.field_0 + var2 * var1.field_0;
      this.field_1 = (1.0F - var2) * this.field_1 + var2 * var1.field_1;
   }

   public Object clone() {
      try {
         return super.clone();
      } catch (CloneNotSupportedException var2) {
         throw new InternalError();
      }
   }
}
