package javax.vecmath;

import java.io.Serializable;

public abstract class Tuple3i implements Serializable, Cloneable {
   static final long serialVersionUID = -732740491767276200L;
   // $FF: renamed from: x int
   public int field_0;
   // $FF: renamed from: y int
   public int field_1;
   // $FF: renamed from: z int
   public int field_2;

   public Tuple3i(int var1, int var2, int var3) {
      this.field_0 = var1;
      this.field_1 = var2;
      this.field_2 = var3;
   }

   public Tuple3i(int[] var1) {
      this.field_0 = var1[0];
      this.field_1 = var1[1];
      this.field_2 = var1[2];
   }

   public Tuple3i(Tuple3i var1) {
      this.field_0 = var1.field_0;
      this.field_1 = var1.field_1;
      this.field_2 = var1.field_2;
   }

   public Tuple3i() {
      this.field_0 = 0;
      this.field_1 = 0;
      this.field_2 = 0;
   }

   public final void set(int var1, int var2, int var3) {
      this.field_0 = var1;
      this.field_1 = var2;
      this.field_2 = var3;
   }

   public final void set(int[] var1) {
      this.field_0 = var1[0];
      this.field_1 = var1[1];
      this.field_2 = var1[2];
   }

   public final void set(Tuple3i var1) {
      this.field_0 = var1.field_0;
      this.field_1 = var1.field_1;
      this.field_2 = var1.field_2;
   }

   public final void get(int[] var1) {
      var1[0] = this.field_0;
      var1[1] = this.field_1;
      var1[2] = this.field_2;
   }

   public final void get(Tuple3i var1) {
      var1.field_0 = this.field_0;
      var1.field_1 = this.field_1;
      var1.field_2 = this.field_2;
   }

   public final void add(Tuple3i var1, Tuple3i var2) {
      this.field_0 = var1.field_0 + var2.field_0;
      this.field_1 = var1.field_1 + var2.field_1;
      this.field_2 = var1.field_2 + var2.field_2;
   }

   public final void add(Tuple3i var1) {
      this.field_0 += var1.field_0;
      this.field_1 += var1.field_1;
      this.field_2 += var1.field_2;
   }

   public final void sub(Tuple3i var1, Tuple3i var2) {
      this.field_0 = var1.field_0 - var2.field_0;
      this.field_1 = var1.field_1 - var2.field_1;
      this.field_2 = var1.field_2 - var2.field_2;
   }

   public final void sub(Tuple3i var1) {
      this.field_0 -= var1.field_0;
      this.field_1 -= var1.field_1;
      this.field_2 -= var1.field_2;
   }

   public final void negate(Tuple3i var1) {
      this.field_0 = -var1.field_0;
      this.field_1 = -var1.field_1;
      this.field_2 = -var1.field_2;
   }

   public final void negate() {
      this.field_0 = -this.field_0;
      this.field_1 = -this.field_1;
      this.field_2 = -this.field_2;
   }

   public final void scale(int var1, Tuple3i var2) {
      this.field_0 = var1 * var2.field_0;
      this.field_1 = var1 * var2.field_1;
      this.field_2 = var1 * var2.field_2;
   }

   public final void scale(int var1) {
      this.field_0 *= var1;
      this.field_1 *= var1;
      this.field_2 *= var1;
   }

   public final void scaleAdd(int var1, Tuple3i var2, Tuple3i var3) {
      this.field_0 = var1 * var2.field_0 + var3.field_0;
      this.field_1 = var1 * var2.field_1 + var3.field_1;
      this.field_2 = var1 * var2.field_2 + var3.field_2;
   }

   public final void scaleAdd(int var1, Tuple3i var2) {
      this.field_0 = var1 * this.field_0 + var2.field_0;
      this.field_1 = var1 * this.field_1 + var2.field_1;
      this.field_2 = var1 * this.field_2 + var2.field_2;
   }

   public String toString() {
      return "(" + this.field_0 + ", " + this.field_1 + ", " + this.field_2 + ")";
   }

   public boolean equals(Object var1) {
      try {
         Tuple3i var2 = (Tuple3i)var1;
         return this.field_0 == var2.field_0 && this.field_1 == var2.field_1 && this.field_2 == var2.field_2;
      } catch (NullPointerException var4) {
         return false;
      } catch (ClassCastException var5) {
         return false;
      }
   }

   public int hashCode() {
      long var1 = 1L;
      var1 = 31L * var1 + (long)this.field_0;
      var1 = 31L * var1 + (long)this.field_1;
      var1 = 31L * var1 + (long)this.field_2;
      return (int)(var1 ^ var1 >> 32);
   }

   public final void clamp(int var1, int var2, Tuple3i var3) {
      if (var3.field_0 > var2) {
         this.field_0 = var2;
      } else if (var3.field_0 < var1) {
         this.field_0 = var1;
      } else {
         this.field_0 = var3.field_0;
      }

      if (var3.field_1 > var2) {
         this.field_1 = var2;
      } else if (var3.field_1 < var1) {
         this.field_1 = var1;
      } else {
         this.field_1 = var3.field_1;
      }

      if (var3.field_2 > var2) {
         this.field_2 = var2;
      } else if (var3.field_2 < var1) {
         this.field_2 = var1;
      } else {
         this.field_2 = var3.field_2;
      }

   }

   public final void clampMin(int var1, Tuple3i var2) {
      if (var2.field_0 < var1) {
         this.field_0 = var1;
      } else {
         this.field_0 = var2.field_0;
      }

      if (var2.field_1 < var1) {
         this.field_1 = var1;
      } else {
         this.field_1 = var2.field_1;
      }

      if (var2.field_2 < var1) {
         this.field_2 = var1;
      } else {
         this.field_2 = var2.field_2;
      }

   }

   public final void clampMax(int var1, Tuple3i var2) {
      if (var2.field_0 > var1) {
         this.field_0 = var1;
      } else {
         this.field_0 = var2.field_0;
      }

      if (var2.field_1 > var1) {
         this.field_1 = var1;
      } else {
         this.field_1 = var2.field_1;
      }

      if (var2.field_2 > var1) {
         this.field_2 = var1;
      } else {
         this.field_2 = var2.field_2;
      }

   }

   public final void absolute(Tuple3i var1) {
      this.field_0 = Math.abs(var1.field_0);
      this.field_1 = Math.abs(var1.field_1);
      this.field_2 = Math.abs(var1.field_2);
   }

   public final void clamp(int var1, int var2) {
      if (this.field_0 > var2) {
         this.field_0 = var2;
      } else if (this.field_0 < var1) {
         this.field_0 = var1;
      }

      if (this.field_1 > var2) {
         this.field_1 = var2;
      } else if (this.field_1 < var1) {
         this.field_1 = var1;
      }

      if (this.field_2 > var2) {
         this.field_2 = var2;
      } else if (this.field_2 < var1) {
         this.field_2 = var1;
      }

   }

   public final void clampMin(int var1) {
      if (this.field_0 < var1) {
         this.field_0 = var1;
      }

      if (this.field_1 < var1) {
         this.field_1 = var1;
      }

      if (this.field_2 < var1) {
         this.field_2 = var1;
      }

   }

   public final void clampMax(int var1) {
      if (this.field_0 > var1) {
         this.field_0 = var1;
      }

      if (this.field_1 > var1) {
         this.field_1 = var1;
      }

      if (this.field_2 > var1) {
         this.field_2 = var1;
      }

   }

   public final void absolute() {
      this.field_0 = Math.abs(this.field_0);
      this.field_1 = Math.abs(this.field_1);
      this.field_2 = Math.abs(this.field_2);
   }

   public Object clone() {
      try {
         return super.clone();
      } catch (CloneNotSupportedException var2) {
         throw new InternalError();
      }
   }
}
