package javax.vecmath;

import java.io.Serializable;

public abstract class Tuple4d implements Serializable, Cloneable {
   static final long serialVersionUID = -4748953690425311052L;
   // $FF: renamed from: x double
   public double field_0;
   // $FF: renamed from: y double
   public double field_1;
   // $FF: renamed from: z double
   public double field_2;
   // $FF: renamed from: w double
   public double field_3;

   public Tuple4d(double var1, double var3, double var5, double var7) {
      this.field_0 = var1;
      this.field_1 = var3;
      this.field_2 = var5;
      this.field_3 = var7;
   }

   public Tuple4d(double[] var1) {
      this.field_0 = var1[0];
      this.field_1 = var1[1];
      this.field_2 = var1[2];
      this.field_3 = var1[3];
   }

   public Tuple4d(Tuple4d var1) {
      this.field_0 = var1.field_0;
      this.field_1 = var1.field_1;
      this.field_2 = var1.field_2;
      this.field_3 = var1.field_3;
   }

   public Tuple4d(Tuple4f var1) {
      this.field_0 = (double)var1.x;
      this.field_1 = (double)var1.y;
      this.field_2 = (double)var1.z;
      this.field_3 = (double)var1.w;
   }

   public Tuple4d() {
      this.field_0 = (double)0.0F;
      this.field_1 = (double)0.0F;
      this.field_2 = (double)0.0F;
      this.field_3 = (double)0.0F;
   }

   public final void set(double var1, double var3, double var5, double var7) {
      this.field_0 = var1;
      this.field_1 = var3;
      this.field_2 = var5;
      this.field_3 = var7;
   }

   public final void set(double[] var1) {
      this.field_0 = var1[0];
      this.field_1 = var1[1];
      this.field_2 = var1[2];
      this.field_3 = var1[3];
   }

   public final void set(Tuple4d var1) {
      this.field_0 = var1.field_0;
      this.field_1 = var1.field_1;
      this.field_2 = var1.field_2;
      this.field_3 = var1.field_3;
   }

   public final void set(Tuple4f var1) {
      this.field_0 = (double)var1.x;
      this.field_1 = (double)var1.y;
      this.field_2 = (double)var1.z;
      this.field_3 = (double)var1.w;
   }

   public final void get(double[] var1) {
      var1[0] = this.field_0;
      var1[1] = this.field_1;
      var1[2] = this.field_2;
      var1[3] = this.field_3;
   }

   public final void get(Tuple4d var1) {
      var1.field_0 = this.field_0;
      var1.field_1 = this.field_1;
      var1.field_2 = this.field_2;
      var1.field_3 = this.field_3;
   }

   public final void add(Tuple4d var1, Tuple4d var2) {
      this.field_0 = var1.field_0 + var2.field_0;
      this.field_1 = var1.field_1 + var2.field_1;
      this.field_2 = var1.field_2 + var2.field_2;
      this.field_3 = var1.field_3 + var2.field_3;
   }

   public final void add(Tuple4d var1) {
      this.field_0 += var1.field_0;
      this.field_1 += var1.field_1;
      this.field_2 += var1.field_2;
      this.field_3 += var1.field_3;
   }

   public final void sub(Tuple4d var1, Tuple4d var2) {
      this.field_0 = var1.field_0 - var2.field_0;
      this.field_1 = var1.field_1 - var2.field_1;
      this.field_2 = var1.field_2 - var2.field_2;
      this.field_3 = var1.field_3 - var2.field_3;
   }

   public final void sub(Tuple4d var1) {
      this.field_0 -= var1.field_0;
      this.field_1 -= var1.field_1;
      this.field_2 -= var1.field_2;
      this.field_3 -= var1.field_3;
   }

   public final void negate(Tuple4d var1) {
      this.field_0 = -var1.field_0;
      this.field_1 = -var1.field_1;
      this.field_2 = -var1.field_2;
      this.field_3 = -var1.field_3;
   }

   public final void negate() {
      this.field_0 = -this.field_0;
      this.field_1 = -this.field_1;
      this.field_2 = -this.field_2;
      this.field_3 = -this.field_3;
   }

   public final void scale(double var1, Tuple4d var3) {
      this.field_0 = var1 * var3.field_0;
      this.field_1 = var1 * var3.field_1;
      this.field_2 = var1 * var3.field_2;
      this.field_3 = var1 * var3.field_3;
   }

   public final void scale(double var1) {
      this.field_0 *= var1;
      this.field_1 *= var1;
      this.field_2 *= var1;
      this.field_3 *= var1;
   }

   public final void scaleAdd(double var1, Tuple4d var3, Tuple4d var4) {
      this.field_0 = var1 * var3.field_0 + var4.field_0;
      this.field_1 = var1 * var3.field_1 + var4.field_1;
      this.field_2 = var1 * var3.field_2 + var4.field_2;
      this.field_3 = var1 * var3.field_3 + var4.field_3;
   }

   /** @deprecated */
   public final void scaleAdd(float var1, Tuple4d var2) {
      this.scaleAdd((double)var1, var2);
   }

   public final void scaleAdd(double var1, Tuple4d var3) {
      this.field_0 = var1 * this.field_0 + var3.field_0;
      this.field_1 = var1 * this.field_1 + var3.field_1;
      this.field_2 = var1 * this.field_2 + var3.field_2;
      this.field_3 = var1 * this.field_3 + var3.field_3;
   }

   public String toString() {
      return "(" + this.field_0 + ", " + this.field_1 + ", " + this.field_2 + ", " + this.field_3 + ")";
   }

   public boolean equals(Tuple4d var1) {
      try {
         return this.field_0 == var1.field_0 && this.field_1 == var1.field_1 && this.field_2 == var1.field_2 && this.field_3 == var1.field_3;
      } catch (NullPointerException var3) {
         return false;
      }
   }

   public boolean equals(Object var1) {
      try {
         Tuple4d var2 = (Tuple4d)var1;
         return this.field_0 == var2.field_0 && this.field_1 == var2.field_1 && this.field_2 == var2.field_2 && this.field_3 == var2.field_3;
      } catch (NullPointerException var4) {
         return false;
      } catch (ClassCastException var5) {
         return false;
      }
   }

   public boolean epsilonEquals(Tuple4d var1, double var2) {
      double var4 = this.field_0 - var1.field_0;
      if ((var4 < (double)0.0F ? -var4 : var4) > var2) {
         return false;
      } else {
         var4 = this.field_1 - var1.field_1;
         if ((var4 < (double)0.0F ? -var4 : var4) > var2) {
            return false;
         } else {
            var4 = this.field_2 - var1.field_2;
            if ((var4 < (double)0.0F ? -var4 : var4) > var2) {
               return false;
            } else {
               var4 = this.field_3 - var1.field_3;
               return !((var4 < (double)0.0F ? -var4 : var4) > var2);
            }
         }
      }
   }

   public int hashCode() {
      long var1 = 1L;
      var1 = 31L * var1 + Double.doubleToLongBits(this.field_0);
      var1 = 31L * var1 + Double.doubleToLongBits(this.field_1);
      var1 = 31L * var1 + Double.doubleToLongBits(this.field_2);
      var1 = 31L * var1 + Double.doubleToLongBits(this.field_3);
      return (int)(var1 ^ var1 >> 32);
   }

   /** @deprecated */
   public final void clamp(float var1, float var2, Tuple4d var3) {
      this.clamp((double)var1, (double)var2, var3);
   }

   public final void clamp(double var1, double var3, Tuple4d var5) {
      if (var5.field_0 > var3) {
         this.field_0 = var3;
      } else if (var5.field_0 < var1) {
         this.field_0 = var1;
      } else {
         this.field_0 = var5.field_0;
      }

      if (var5.field_1 > var3) {
         this.field_1 = var3;
      } else if (var5.field_1 < var1) {
         this.field_1 = var1;
      } else {
         this.field_1 = var5.field_1;
      }

      if (var5.field_2 > var3) {
         this.field_2 = var3;
      } else if (var5.field_2 < var1) {
         this.field_2 = var1;
      } else {
         this.field_2 = var5.field_2;
      }

      if (var5.field_3 > var3) {
         this.field_3 = var3;
      } else if (var5.field_3 < var1) {
         this.field_3 = var1;
      } else {
         this.field_3 = var5.field_3;
      }

   }

   /** @deprecated */
   public final void clampMin(float var1, Tuple4d var2) {
      this.clampMin((double)var1, var2);
   }

   public final void clampMin(double var1, Tuple4d var3) {
      if (var3.field_0 < var1) {
         this.field_0 = var1;
      } else {
         this.field_0 = var3.field_0;
      }

      if (var3.field_1 < var1) {
         this.field_1 = var1;
      } else {
         this.field_1 = var3.field_1;
      }

      if (var3.field_2 < var1) {
         this.field_2 = var1;
      } else {
         this.field_2 = var3.field_2;
      }

      if (var3.field_3 < var1) {
         this.field_3 = var1;
      } else {
         this.field_3 = var3.field_3;
      }

   }

   /** @deprecated */
   public final void clampMax(float var1, Tuple4d var2) {
      this.clampMax((double)var1, var2);
   }

   public final void clampMax(double var1, Tuple4d var3) {
      if (var3.field_0 > var1) {
         this.field_0 = var1;
      } else {
         this.field_0 = var3.field_0;
      }

      if (var3.field_1 > var1) {
         this.field_1 = var1;
      } else {
         this.field_1 = var3.field_1;
      }

      if (var3.field_2 > var1) {
         this.field_2 = var1;
      } else {
         this.field_2 = var3.field_2;
      }

      if (var3.field_3 > var1) {
         this.field_3 = var1;
      } else {
         this.field_3 = var3.field_2;
      }

   }

   public final void absolute(Tuple4d var1) {
      this.field_0 = Math.abs(var1.field_0);
      this.field_1 = Math.abs(var1.field_1);
      this.field_2 = Math.abs(var1.field_2);
      this.field_3 = Math.abs(var1.field_3);
   }

   /** @deprecated */
   public final void clamp(float var1, float var2) {
      this.clamp((double)var1, (double)var2);
   }

   public final void clamp(double var1, double var3) {
      if (this.field_0 > var3) {
         this.field_0 = var3;
      } else if (this.field_0 < var1) {
         this.field_0 = var1;
      }

      if (this.field_1 > var3) {
         this.field_1 = var3;
      } else if (this.field_1 < var1) {
         this.field_1 = var1;
      }

      if (this.field_2 > var3) {
         this.field_2 = var3;
      } else if (this.field_2 < var1) {
         this.field_2 = var1;
      }

      if (this.field_3 > var3) {
         this.field_3 = var3;
      } else if (this.field_3 < var1) {
         this.field_3 = var1;
      }

   }

   /** @deprecated */
   public final void clampMin(float var1) {
      this.clampMin((double)var1);
   }

   public final void clampMin(double var1) {
      if (this.field_0 < var1) {
         this.field_0 = var1;
      }

      if (this.field_1 < var1) {
         this.field_1 = var1;
      }

      if (this.field_2 < var1) {
         this.field_2 = var1;
      }

      if (this.field_3 < var1) {
         this.field_3 = var1;
      }

   }

   /** @deprecated */
   public final void clampMax(float var1) {
      this.clampMax((double)var1);
   }

   public final void clampMax(double var1) {
      if (this.field_0 > var1) {
         this.field_0 = var1;
      }

      if (this.field_1 > var1) {
         this.field_1 = var1;
      }

      if (this.field_2 > var1) {
         this.field_2 = var1;
      }

      if (this.field_3 > var1) {
         this.field_3 = var1;
      }

   }

   public final void absolute() {
      this.field_0 = Math.abs(this.field_0);
      this.field_1 = Math.abs(this.field_1);
      this.field_2 = Math.abs(this.field_2);
      this.field_3 = Math.abs(this.field_3);
   }

   /** @deprecated */
   public void interpolate(Tuple4d var1, Tuple4d var2, float var3) {
      this.interpolate(var1, var2, (double)var3);
   }

   public void interpolate(Tuple4d var1, Tuple4d var2, double var3) {
      this.field_0 = ((double)1.0F - var3) * var1.field_0 + var3 * var2.field_0;
      this.field_1 = ((double)1.0F - var3) * var1.field_1 + var3 * var2.field_1;
      this.field_2 = ((double)1.0F - var3) * var1.field_2 + var3 * var2.field_2;
      this.field_3 = ((double)1.0F - var3) * var1.field_3 + var3 * var2.field_3;
   }

   /** @deprecated */
   public void interpolate(Tuple4d var1, float var2) {
      this.interpolate(var1, (double)var2);
   }

   public void interpolate(Tuple4d var1, double var2) {
      this.field_0 = ((double)1.0F - var2) * this.field_0 + var2 * var1.field_0;
      this.field_1 = ((double)1.0F - var2) * this.field_1 + var2 * var1.field_1;
      this.field_2 = ((double)1.0F - var2) * this.field_2 + var2 * var1.field_2;
      this.field_3 = ((double)1.0F - var2) * this.field_3 + var2 * var1.field_3;
   }

   public Object clone() {
      try {
         return super.clone();
      } catch (CloneNotSupportedException var2) {
         throw new InternalError();
      }
   }
}
